Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon
Interface Platform

All Superinterfaces:
  Serializable

All Known Implementing Classes:
  JavaPlatform

    public interface Platform

extends Serializable

This interface provides access to methods whose implementation depends on the chosen platform (typically Java or .NET)

Method Summary
`void` | `addFunctionLibraries(FunctionLibraryList list, Configuration config)` Add platform-specific function libraries to the function library list
`boolean` | `canReturnCollationKeys(StringCollator collation)` Given a collation, determine whether it is capable of returning collation keys.
`RegularExpression` | `compileRegularExpression(CharSequence regex, boolean isXPath, CharSequence flags)` Create a compiled regular expression
`void` | `declareJavaClass(FunctionLibrary library, String uri, Class theClass)` Register a namespace-to-Java-class mapping declared using saxon:script in an XSLT stylesheet
`Object` | `getCollationKey(NamedCollation namedCollation, String value)` Given a collation, get a collation key.
`SchemaType` | `getExternalObjectType(Configuration config, String uri, String localName)`
`Source` | `getParserSource(Configuration config, StreamSource input, int validation, boolean dtdValidation, int stripspace)` Convert a StreamSource to either a SAXSource or a PullSource, depending on the native parser of the selected platform
`String` | `getPlatformSuffix()` Get a suffix letter to add to the Saxon version number to identify the platform
`String` | `getPlatformVersion()` Get the platform version
`void` | `initialize(Configuration config)` Perform platform-specific initialization of the configuration
`boolean` | `isDotNet()` Return true if this is the .NET platform
`boolean` | `isJava()` Return true if this is the Java platform
`URI` | `makeAbsolute(String relativeURI, String base)` Construct an absolute URI from a relative URI and a base URI
`StringCollator` | `makeCollation(Configuration config, Properties props, String uri)` Obtain a collation with a given set of properties.
`FunctionLibrary` | `makeExtensionLibrary(Configuration config)` Make the default extension function factory appropriate to the platform

Method Detail

### initialize

    void initialize(Configuration config)

  Perform platform-specific initialization of the configuration

### isJava

    boolean isJava()

  Return true if this is the Java platform

### isDotNet

    boolean isDotNet()

  Return true if this is the .NET platform

### makeAbsolute

    URI makeAbsolute(String relativeURI,
                     String base)
                     throws URISyntaxException

  Construct an absolute URI from a relative URI and a base URI

  Parameters:
    `relativeURI` - the relative URI. Null is permitted provided that the base URI is an absolute URI
    `base` - the base URI
  Returns:
    the absolutized URI
  Throws:
    `URISyntaxException`

### getPlatformVersion

    String getPlatformVersion()

  Get the platform version

### getPlatformSuffix

    String getPlatformSuffix()

  Get a suffix letter to add to the Saxon version number to identify the platform

### getParserSource

    Source getParserSource(Configuration config,
                           StreamSource input,
                           int validation,
                           boolean dtdValidation,
                           int stripspace)

  Convert a StreamSource to either a SAXSource or a PullSource, depending on the native parser of the selected platform

  Parameters:
    `config` -
    `input` - the supplied StreamSource
    `validation` -
    `dtdValidation` -
    `stripspace` -
  Returns:
    the PullSource or SAXSource, initialized with a suitable parser, or the original input Source, if now special handling is required or possible

### compileRegularExpression

    RegularExpression compileRegularExpression(CharSequence regex,
                                               boolean isXPath,
                                               CharSequence flags)
                                               throws XPathException

  Create a compiled regular expression

  Parameters:
    `regex` - the source text of the regular expression, in XML Schema or XPath syntax
    `isXPath` - set to true if this is an XPath regular expression, false if it is XML Schema
    `flags` - the flags argument as supplied to functions such as fn:matches(), in string form
  Returns:
    the compiled regular expression
  Throws:
    `XPathException` - if the syntax of the regular expression or flags is incorrect

### makeCollation

    StringCollator makeCollation(Configuration config,
                                 Properties props,
                                 String uri)
                                 throws XPathException

  Obtain a collation with a given set of properties. The set of properties is extensible and variable across platforms. Common properties with example values include lang=ed-GB, strength=primary, case-order=upper-first, ignore-modifiers=yes, alphanumeric=yes. Properties that are not supported are generally ignored; however some errors, such as failing to load a requested class, are fatal.

  Parameters:
    `config` - the configuration object
    `props` - the desired properties of the collation
    `uri` -
  Returns:
    a collation with these properties
  Throws:
    `XPathException` - if a fatal error occurs

### canReturnCollationKeys

    boolean canReturnCollationKeys(StringCollator collation)

  Given a collation, determine whether it is capable of returning collation keys. The essential property of collation keys is that if two values are equal under the collation, then the collation keys are equal under the equals() method.

  Parameters:
    `collation` - the collation being examined, provided as a Comparator
  Returns:
    true if this collation can supply collation keys

### getCollationKey

    Object getCollationKey(NamedCollation namedCollation,
                           String value)

  Given a collation, get a collation key. The essential property of collation keys is that if two values are equal under the collation, then the collation keys are equal under the equals() method.

  Returns:
    a representation of the collation key, such that two collation keys are equal() if and only if the string values they represent are equal under the specified collation.
  Throws:
    `ClassCastException` - if the collation is not one that is capable of supplying collation keys (this should have been checked in advance)

### makeExtensionLibrary

    FunctionLibrary makeExtensionLibrary(Configuration config)

  Make the default extension function factory appropriate to the platform

### addFunctionLibraries

    void addFunctionLibraries(FunctionLibraryList list,
                              Configuration config)

  Add platform-specific function libraries to the function library list

### declareJavaClass

    void declareJavaClass(FunctionLibrary library,
                          String uri,
                          Class theClass)

  Register a namespace-to-Java-class mapping declared using saxon:script in an XSLT stylesheet

  Parameters:
    `library` - the library to contain the function, which must be a JavaExtensionLibrary
    `uri` - the namespace of the function name
    `theClass` - the Java class that implements this namespace

### getExternalObjectType

    SchemaType getExternalObjectType(Configuration config,
                                     String uri,
                                     String localName)

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.